<?php
// 应用公共文件

/**
 * @param $url
 * @return array
 */
function curl_get($url){

    $headerArray = array("Content-type:application/json;", "Accept:application/json;");
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headerArray);
    $output = curl_exec($ch);
    curl_close($ch);
    return $output = json_decode($output, true);


}

/**
 * @param $url
 * @param array $data
 * @param $headerArray
 * @return array
 */
function curl_post($url , $data=array(),$headerArray){
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headerArray);
    // POST数据
    curl_setopt($ch, CURLOPT_POST, 1);
    // 把post的变量加上
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    $output = curl_exec($ch);
    curl_close($ch);
    return $output = json_decode($output, true);;

}

/**
 * 判断是否为合法的身份证号码
 * @param $IDcard
 * @return boolean
 */
function isCreditNo($vStr){

    $vCity = array(
        '11','12','13','14','15','21','22',
        '23','31','32','33','34','35','36',
        '37','41','42','43','44','45','46',
        '50','51','52','53','54','61','62',
        '63','64','65','71','81','82','91'
    );
    if (!preg_match('/^([\d]{17}[xX\d]|[\d]{15})$/', $vStr)) return false;
    if (!in_array(substr($vStr, 0, 2), $vCity)) return false;
    $vStr = preg_replace('/[xX]$/i', 'a', $vStr);
    $vLength = strlen($vStr);
    if ($vLength == 18) {
        $vBirthday = substr($vStr, 6, 4) . '-' . substr($vStr, 10, 2) . '-' . substr($vStr, 12, 2);
    } else {
        $vBirthday = '19' . substr($vStr, 6, 2) . '-' . substr($vStr, 8, 2) . '-' . substr($vStr, 10, 2);
    }
    if (date('Y-m-d', strtotime($vBirthday)) != $vBirthday) return false;
    if ($vLength == 18) {
        $vSum = 0;
        for ($i = 17 ; $i >= 0 ; $i--) {
            $vSubStr = substr($vStr, 17 - $i, 1);
            $vSum += (pow(2, $i) % 11) * (($vSubStr == 'a') ? 10 : intval($vSubStr , 11));
        }
        if($vSum % 11 != 1) return false;
    }
    return true;
}

//获取毫秒时间戳
function msectime(){
    list($msec, $sec) = explode(' ', microtime());
    $msectime = (float)sprintf('%.0f', (floatval($msec) + floatval($sec)) * 1000);
    return $msectime;
}

/**
 * 生成随机字符串
 *
 * @return string
 */
function getRandomStr($length=16)
{
    $str = '';
    $str_pol = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyl';
    $max = strlen($str_pol) - 1;
    for ($i = 0; $i < $length; $i++) {
        $str .= $str_pol[mt_rand(0, $max)];
    }
    return $str;
}


//见证手机号是否合法
function isPhoneNo($phone){
    if(preg_match("/^1[34578]\d{9}$/", $phone)){
        return true;
    } else {
        return false;
    }
}

//图片上传

//文件下载
function downloadFile($file,$file_name) {
    ob_clean();
    if(!file_exists($file)){
        echo "文件不存在";
        return;
    }

    $fp=fopen($file,"r");

    //取得文件大小
    $file_Size=filesize($file);

    header("Content-type:application/octet-stream");
    header("Accept-Ranges:bytes");
    header("Accept-Length:".$file_Size);
    if(!$file_name){
        $fileArr = explode('/',$file);
        $file_name = end($fileArr);
    }
    header("Content-Disposition: attachment; filename=".$file_name);

    $buffer=1024;
    $buffer_count=0;

    while(!feof($fp)&&$file_Size-$buffer_count>0){
        $data=fread($fp,$buffer);
        $buffer_count+=$buffer;
        echo $data;

    }

    fclose($fp);
}

//生成短信验证码
function createPhoneCode($length) {
    return substr(str_shuffle("012345678901234567890123456789"), 0, $length);;
}







