<?php


namespace app\shequ\controller;


//关于订单的接口
use app\admin\controller\Common;
use think\facade\Db;
use think\facade\Request;

class Order extends Base
{
    protected $middleware = ['app\middleware\CommunityLoginCheck::class','app\middleware\CommunityAfter::class'];
    public function orderList() {

        //流水管理
        $page = Request::param('page',1);
        if(Request::param('income')) {
            $where[] = ['ml.income','=',Request::param('income')];
        }
        $where[] = ['ml.village_id','=',$this->village_id];
        if(Request::param('start_time') && Request::param('end_time') ) {
            $start_time = strtotime(Request::param('start_time'));
            $end_time = strtotime(Request::param('end_time'));
            if($start_time >= $end_time) {
                return $this->returnJson([],'开始时间不能大于结束时间!',400);
            }
            $where[] = ['ml.create_time','between',[$start_time,$end_time]];
        }
        $rest = Common::getWithDrawList($where,$page);
        $res['total'] = $rest['total'];
        $res['data'] = Common::changeField($rest['data']);
        return $this->returnJson($res,'success');

    }

    //查看流水详情
    public function detailOrder() {
        $id = Request::param('id');
        $where['id'] = $id;
        $rest =  Common::getWithDrawDetail($where);
        if(!$rest) {
            return $this->returnJson([],'暂未获取到任何数据',400);
        }
        $res['data'] = $rest['data'];
        $res['orderInfo'] = Common::changeField($rest['orderInfo'],['create_time','pay_time']);
        return $this->returnJson($res,'success');

    }

}